program WheelApp;

{---------------------------------------------------------------------
Example application for the custom control Wheel (Wheels.DLL) of
the SMWCC 2.0 Custom Control Pack

Copyright (C) by Sebastian Modersohn

Note: This code file isn't documented into detail. If you have
      questions to *THIS* code file or want to know some details
      please contact me via CompuServe, ID 100340,1474.
---------------------------------------------------------------------}

{$IFNDEF AUTOLOAD}

  You HAVE to compile this program with the global defined symbol "AUTOLOAD" !
  This demonstrates the autoloading feature of the import unit Color!
{$ENDIF}

 {$R WheelApp}

uses WinTypes, WinProcs, OWindows, ODialogs, Strings, BWCC,
     {the import unit and the constant unit for the control}
     Wheel, WheelCo;

{some Id's}
const id_Wheel       =101;
      id_Text1       =102;
      id_Text2       =103;

type
  pWheelWindow = ^tWheelWindow;
  tWheelWindow = object(tDlgWindow)
    Wheel: pWheel;
    constructor Init(AParent: PWindowsObject; AName: PChar);

    procedure WMWheel(var Msg: TMessage);
      virtual id_first + id_Wheel;

    procedure Ok(var Msg: TMessage);
      virtual id_First + id_OK;
    procedure Help(var Msg: TMessage);
      virtual id_First + idHelp;
  end;

{App that initializes the main window}
  pWheelApp = ^tWheelApp;
  tWheelApp = object(tApplication)
    procedure InitMainWindow; virtual;
  end;

{ tWheelWindow }

constructor tWheelWindow.Init(AParent: PWindowsObject; AName: PChar);
begin
  inherited Init(AParent, AName);
  {simple initializing with the Parent (@Self) and the ID}
  Wheel:=New(pWheel, InitResource(@Self, id_Wheel));
end;

{Notification message for monitoring the changes of the Wheel}
procedure TWheelWindow.WMWheel(var Msg: TMessage);
var Strg: array [0..3] of Char;
begin
  case Msg.lParam of
    wn_TrackSel:
      begin
        Str(Wheel^.GetVal, Strg);
        SetDlgItemText(HWindow, id_Text1, Strg);
      end;
    wn_SelChange:
      begin
        Str(Wheel^.GetVal, Strg);
        SetDlgItemText(HWindow, id_Text1, Strg);
        SetDlgItemText(HWindow, id_Text2, Strg);
      end;
  end; {case}
end;

procedure TWheelWindow.Ok(var Msg: TMessage);
begin
  CloseWindow;
end;

procedure TWheelWindow.Help(var Msg: TMessage);
begin
  WinHelp(HWindow, HelpFile, Help_Context, 100);
end;

{ TWheelApp }

procedure TWheelApp.InitMainWindow;
begin
  MainWindow := New(PWheelWindow, Init(nil, MakeIntResource(100)));
end;

var
  App: TWheelApp;

begin
  App.Init('Wheel Demo');
  App.Run;
  App.Done;
end.
